package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesDataObject;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IDataObjectExtService {

    /**
     * 按条件分页查询数据对象信息
     *
     * @param dataObject 查询条件
     * @param pager 分页条件
     * @return 数据对象信息分页集合
     */
    @ApiOperation(value = "按条件分页查询数据对象信息", notes = "按条件分页查询数据对象信息")
    ListPager<MesDataObject> queryDataObjectByPager(MesDataObject dataObject, Pager pager);

    /**
     * 新增数据对象信息
     * @param dataObject 数据对象信息
     * @return 数据对象信息
     */
    @ApiOperation(value = "新增数据对象信息", notes = "新增数据对象信息")
    MesDataObject insertDataObject(MesDataObject dataObject);

    /**
     * 更新数据对象信息
     * @param dataObject 数据对象信息
     * @return 数据对象信息
     */
    @ApiOperation(value = "更新数据对象信息", notes = "更新数据对象信息")
    MesDataObject updateDataObject(MesDataObject dataObject);

    /**
     * 根据id启用或禁用数据对象信息
     * @param id 数据对象信息ID
     * @param status 状态
     * @param organizeCode 组织代码
     * @param userName 操作人
     * @return 结果
     */
    @ApiOperation(value = "根据id启用或禁用数据对象信息", notes = "根据id启用或禁用数据对象信息")
    int updateDataObjectValidById(Long id, Integer status, String organizeCode, String userName);

    /**
     * 获取数据对象信息集合
     *
     * @param organizeCode 组织代码
     * @return 数据对象信息集合
     */
    @ApiOperation(value = "获取数据对象信息集合", notes = "获取数据对象信息集合")
    List<MesDataObject> queryDataObjectList(String organizeCode);

}
