package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesProcessCell;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IMesProcessCellService {
    /**
     * 新增工序工位关系
     *
     * @param mesProcessCell
     * @return
     */
    @ApiOperation(value = "新增工序工位关系", notes = "新增工序工位关系")
    MesProcessCell insertMesProcessCell(MesProcessCell mesProcessCell);

    /**
     * 按条件分页查询工序工位对应关系信息
     *
     * @param mesProcessCell
     * @param pager
     * @return
     */
    @ApiOperation(value = "按条件分页查询工序工位对应关系信息", notes = "按条件分页查询工序工位对应关系信息")
    ListPager<MesProcessCell> queryMesProcessCellByPager(MesProcessCell mesProcessCell, Pager pager);


    /**
     * 更新工序工位对应关系信息
     *
     * @param mesProcessCell 工序工位对应关系
     * @return 更新后的工序工位对应关系
     */
    @ApiOperation(value = "更新工序工位对应关系信息", notes = "更新工序工位对应关系信息")
    MesProcessCell updateMesProcessCell(MesProcessCell mesProcessCell);


    /**
     * 启用/禁用工序工位关系
     * @param id
     * @param status
     * @return
     */
    @ApiOperation(value = "启用/禁用工序工位关系", notes = "启用/禁用工序工位关系")
    int updateStatusProcessCell(long id,Integer status);

}
