package cn.estsh.i3plus.ext.mes.api.base.bu3;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesEsopCenterRemainCfg;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface ISxEsopCenterRemainCfgService {

    /**
     * 按条件分页查询作业指导书生产线切替数量配置信息
     *
     * @param esopCenterRemainCfg 查询条件
     * @param pager 分页条件
     * @return 作业指导书生产线切替数量配置分页数据
     */
    @ApiOperation(value = "按条件分页查询作业指导书生产线切替数量配置信息", notes = "按条件分页查询作业指导书生产线切替数量配置信息")
    ListPager<MesEsopCenterRemainCfg> queryEsopCenterRemainCfgByPager(MesEsopCenterRemainCfg esopCenterRemainCfg, Pager pager);

    /**
     * 新增作业指导书生产线切替数量配置信息
     * @param esopCenterRemainCfg 作业指导书生产线切替数量配置信息
     * @return 作业指导书生产线切替数量配置数据
     */
    @ApiOperation(value = "新增作业指导书生产线切替数量配置信息", notes = "新增作业指导书生产线切替数量配置信息")
    MesEsopCenterRemainCfg insertEsopCenterRemainCfg(MesEsopCenterRemainCfg esopCenterRemainCfg);

    /**
     * 更新作业指导书生产线切替数量配置信息
     * @param esopCenterRemainCfg 作业指导书生产线切替数量配置信息
     * @return 作业指导书生产线切替数量配置数据
     */
    @ApiOperation(value = "更新作业指导书生产线切替数量配置信息", notes = "更新作业指导书生产线切替数量配置信息")
    MesEsopCenterRemainCfg updateEsopCenterRemainCfg(MesEsopCenterRemainCfg esopCenterRemainCfg);

    /**
     * 根据id启用或禁用作业指导书生产线切替数量配置信息
     * @param idStr 作业指导书生产线切替数量配置信息ID
     * @param status 状态
     * @param userName 操作人
     */
    @ApiOperation(value = "根据id启用或禁用作业指导书生产线切替数量配置信息", notes = "根据id启用或禁用作业指导书生产线切替数量配置信息")
    void updateEsopCenterRemainCfgValidById(String idStr, Integer status, String userName);

    /**
     * 根据id删除作业指导书生产线切替数量配置信息
     * @param idStr 作业指导书生产线切替数量配置信息ID
     * @param userName 操作人
     */
    @ApiOperation(value = "根据id删除作业指导书生产线切替数量配置信息", notes = "根据id删除作业指导书生产线切替数量配置信息")
    void deleteEsopCenterRemainCfgById(String idStr, String userName);

    /**
     * 获取作业指导书生产线切替数量配置信息
     * @param organizeCode 组织代码
     * @return 作业指导书生产线切替数量配置信息
     */
    @ApiOperation(value = "获取作业指导书生产线切替数量配置信息", notes = "获取作业指导书生产线切替数量配置信息")
    List<MesEsopCenterRemainCfg> getEsopCenterRemainCfgAllList(String organizeCode);

}
