package cn.estsh.i3plus.ext.mes.api.busi.bu3;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesDailyCheckConfirmRecord;
import cn.estsh.i3plus.ext.mes.pojo.model.bu3.SxDailyCheckConfirmRecordDataModel;
import cn.estsh.i3plus.ext.mes.pojo.model.bu3.SxDailyCheckConfirmRecordModel;
import io.swagger.annotations.ApiOperation;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

public interface ISxDailyCheckConfirmRecordService {

    /**
     * 日常点检报表确认记录
     * @param data 查询条件
     * @return 日常点检报表确认记录
     */
    @ApiOperation(value = "日常点检报表确认记录", notes = "日常点检报表确认记录")
    List<MesDailyCheckConfirmRecord> confirmList(SxDailyCheckConfirmRecordModel data);

    /**
     * 确认记录写入
     * @param data 确认记录
     */
    @ApiOperation(value = "确认记录写入", notes = "确认记录写入")
    void insertConfirm(SxDailyCheckConfirmRecordModel data);

    /**
     * 日常点检报表确认记录报表
     * @param data 查询条件
     * @return 日常点检报表确认记录报表
     */
    @ApiOperation(value = "日常点检报表确认记录报表", notes = "日常点检报表确认记录报表")
    SxDailyCheckConfirmRecordDataModel queryDailyCheckConfirmRecordData(SxDailyCheckConfirmRecordDataModel data);

    /**
     * 日常点检报表确认
     * @param data 确认条件
     */
    @ApiOperation(value = "日常点检报表确认", notes = "日常点检报表确认")
    void doConfirmDailyCheckConfirmRecordData(SxDailyCheckConfirmRecordModel data);

    /**
     * 日常点检报表确认记录报表上传
     * @param resp HttpServletResponse
     * @param data 查询条件
     */
    @ApiOperation(value = "日常点检报表确认记录报表上传", notes = "日常点检报表确认记录报表上传")
    void doDownLoadDailyCheckConfirmRecordData(HttpServletResponse resp, SxDailyCheckConfirmRecordDataModel data);
}
