package cn.estsh.i3plus.ext.mes.apiservice.dao;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesConsistencyAffirmRecord;
import cn.estsh.i3plus.ext.mes.pojo.bean.MesOrderJob;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/01/22 17:33
 * @Description:
 **/
public interface IConsistencyAffirmRecordDao {

    /**
     * 一致性确认记录报表
     * 按条件分页查询一致性确认记录详情
     * @param consistencyAffirmRecord
     * @param pager
     * @return
     */
    @ApiOperation(value = "按条件分页查询一致性确认记录详情", notes = "按条件分页查询一致性确认记录详情")
    List<MesConsistencyAffirmRecord> queryConsistencyAffirmRecordByPager(MesConsistencyAffirmRecord consistencyAffirmRecord, Pager pager);

    /**
     * 按条件查找单据作业分页数量
     *
     * @param consistencyAffirmRecord
     * @return
     */
    @ApiOperation(value = "按条件查找单据作业分页数量", notes = "按条件查找单据作业分页数量")
    int queryConsistencyAffirmRecordCount(MesConsistencyAffirmRecord consistencyAffirmRecord);
}
