package cn.estsh.i3plus.ext.mes.apiservice.dao;


import cn.estsh.i3plus.ext.mes.pojo.bean.MesPartExt;
import cn.estsh.i3plus.ext.mes.pojo.model.MesPartExtModel;
import cn.estsh.i3plus.pojo.base.common.Pager;

import java.util.List;
import java.util.Map;

/**
 * @Description : MES物料信息Dao
 * @Reference :
 * @Author : xiangming.liao
 * @CreateDate : 2020-02-21
 * @Modify:
 **/
public interface IPartExtDao {

    /**
     * 查询物料信息数量
     * @param partExt 物料信息
     * @return 数量
     */
    int queryPartByPagerCount(MesPartExt partExt);

    /**
     * 查询物料信息集合
     * @param partExt 查询条件
     * @param pager 分页条件
     * @return 物料信息集合
     */
    List<MesPartExtModel> queryPartByPager(MesPartExt partExt, Pager pager);

    /**
     * 查询物料标准工数集合
     * @param organizeCode 组织代码
     * @return 物料标准工数集合
     */
    Map<String, Double> queryPartExtStandardWorkMap(String organizeCode);

    /**
     * 查询物料标准工数集合
     * @param organizeCode 组织代码
     * @return 物料标准工数集合
     */
    Map<String, String> queryPartExtStandardWorkStrMap(String organizeCode);

    /**
     * 查询物料产品类别集合
     * @param organizeCode 组织代码
     * @param categoryCode3 产品类别
     * @return 物料产品类别集合
     */
    Map<String, String> queryPartCategoryCode3Map(String organizeCode, String categoryCode3);

    /**
     * 查询物料产品类别集合
     * @param organizeCode 组织代码
     * @param categoryCode3Map 产品类别
     * @return 物料产品类别集合
     */
    Map<String, String> queryPartCategoryCode3Map(String organizeCode, Map<String, String> categoryCode3Map);

    /**
     * 查询物料单价集合
     * @param organizeCode 组织代码
     * @return 物料单价集合
     */
    Map<String, Double> queryPartExtPartPriceMap(String organizeCode);
}
