package cn.estsh.i3plus.ext.mes.pojo.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/1/15 15:32
 **/
@Data
@ApiModel("达成率/完结率一览表 报表model")
public class CompleteRateChartModel implements Serializable {

    private static final long serialVersionUID = 4491896849575565576L;

    @ApiParam("作业时间")
    private String workTime;

    @ApiParam("工作中心代码")
    private String workCenterCode;

    @ApiParam("工作中心名称")
    private String workCenterName;

    @ApiParam("系别")
    private String isDont;

    @ApiParam("班别")
    private String dontClass;

    @ApiParam("产品类别")
    private String categoryCode3;

    @ApiParam("产品类别名称")
    private String categoryCode3Name;

    @ApiParam("生产工单号")
    private String workOrderNo;

    @ApiParam("工单状态")
    private Integer workOrderStatus;

    @ApiParam("物料编码")
    private String partNo;

    @ApiParam("物料名称")
    private String partNameRdd;

    @ApiParam("计划")
    private Double planQty;

    @ApiParam("实绩")
    private Double qty = 0.0;

    @ApiParam("工单开始时间")
    private String orderStartTime;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("作业时间开始")
    private String workTimeStart;

    @ApiParam("作业时间结束")
    private String workTimeEnd;

    @ApiParam("达成率")
    private String attainmentRate;

    @ApiParam("完结率")
    private String completeRate;

    @ApiParam("查询维度")
    private Integer dimension;

    @ApiParam("查询维度")
    private Integer dimension1;

    @ApiParam("复用计划开始时间")
    private String reusePlanDatetimeStart;

    @ApiParam("复用计划截止时间")
    private String reusePlanDatetimeEnd;

    public CompleteRateChartModel() {
    }

    //达成率/完结率一览表
    public CompleteRateChartModel(String workTime, String workCenterCode, String workOrderNo, String partNo, String partNameRdd,
                                  Double planQty, Double qty, String orderStartTime, String categoryCode3, String workCenterName, String isDont, String dontClass) {
        this.workTime = workTime;
        this.workCenterCode = workCenterCode;
        this.workOrderNo = workOrderNo;
        this.partNo = partNo;
        this.partNameRdd = partNameRdd;
        this.planQty = planQty;
        this.qty = qty;
        this.orderStartTime = orderStartTime;
        this.categoryCode3 = categoryCode3;
        this.workCenterName = workCenterName;
        this.isDont = isDont;
        this.dontClass = dontClass;
    }

    //达成率/完结率一览表
    public CompleteRateChartModel(String workTime, String workCenterCode, String workOrderNo, Integer workOrderStatus, String partNo, String partNameRdd,
                                  Double planQty, String orderStartTime, String categoryCode3, String workCenterName, String isDont, String dontClass) {
        this.workTime = workTime;
        this.workCenterCode = workCenterCode;
        this.workOrderNo = workOrderNo;
        this.workOrderStatus = workOrderStatus;
        this.partNo = partNo;
        this.partNameRdd = partNameRdd;
        this.planQty = planQty;
        this.orderStartTime = orderStartTime;
        this.categoryCode3 = categoryCode3;
        this.workCenterName = workCenterName;
        this.isDont = isDont;
        this.dontClass = dontClass;
    }
}
