package cn.estsh.i3plus.ext.mes.pojo.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/02/03 9:35
 * @Description:
 **/
@Data
@ApiModel("工序BOM导出model")
public class ExcelProcessBomModel implements Serializable{
    private static final long serialVersionUID = -4166211662486840954L;

    @ApiParam("成品物料编码")
    private String partNo;

    @ApiParam("成品物料名称")
    private String partNameRdd;

    @ApiParam("原材料物料编码")
    private String itemPartNo;

    @ApiParam("原材料物料名称")
    private String itemPartName;

    @ApiParam("工序代码")
    private String processCode;

    @ApiParam("工序名称")
    private String processName;

    @ApiParam(value = "物料数量", example = "0")
    private Double qty;

    /**
     *匹配规则：10=条码规则匹配、20=箱条码匹配、30=过程条码匹配、40=物料编码匹配。
     */
    @ApiParam(value = "匹配规则")
    private Integer matchRule;

    @ApiParam("是否绑定")
    private Integer isBind;

    @ApiParam("创建用户")
    private String createUser;

    @ApiParam("创建日期")
    private String createDatetime;

    @ApiParam("修改人")
    private String modifyUser;

    @ApiParam("修改日期")
    private String modifyDatetime;
}
